#####################################################################
# Daniel Calderon S.
# CC3501-1
#####################################################################

import pygame
from pygame.locals import *
from OpenGL.GL import *
from OpenGL.GLU import *
from random import uniform
from math import *
from string import *
from Vector import *

#####################################################################

epsilon=1

#####################################################################

class Circulo:
    def __init__(self, r, p, v, rgb, nt):

        self.r = r
        self.p = p
        self.v = v
        self.rgb = []
        self.rgb.append(rgb[0])
        self.rgb.append(rgb[1])
        self.rgb.append(rgb[2])
        self.elim = False

        self.t = []
        
        a=2*pi/nt

        for i in range(nt):
            ai=a*i
            self.t.append(Vector(cos(ai),sin(ai)))

    def mover(self,dt):
        self.v=sumar(self.v,ponderar(dt,g))
        self.p=sumar(self.p,ponderar(dt,self.v))

    def detener(self):
        self.g=Vector(0.0,0.0)
        
    def dibujar(self):
        glPushMatrix()
        
        glTranslatef(self.p.x,self.p.y,0.0)
        glScalef(self.r,self.r,0.0)
        glColor4f(self.rgb[0],self.rgb[1],self.rgb[2],0.0)

        glBegin(GL_TRIANGLE_FAN)
        
        glVertex4f( 0.0, 0.0, 0.0 , 1.0)

        for v in self.t:
            glVertex4f( v.x, v.y, 0.0 , 1.0)

        glVertex4f(self.t[0].x,self.t[0].y, 0.0 , 1.0)
                
        glEnd()
        glPopMatrix()

    def dibujarT(self):
        glPushMatrix()
        
        glTranslatef(self.p.x,self.p.y,0.0)
        glScalef(self.r,self.r,0.0)
        glColor4f(self.rgb[0],self.rgb[1],self.rgb[2],0.0)
        
        glBegin(GL_LINES)

        n=len(self.t)-1

        for i in range(n):
            glVertex4f(0.0, 0.0, 0.0 , 1.0)
            glVertex4f(self.t[i].x, self.t[i].y, 0.0 , 1.0)
            glVertex4f(self.t[i].x, self.t[i].y, 0.0 , 1.0)
            glVertex4f(self.t[i+1].x, self.t[i+1].y, 0.0 , 1.0)

        glVertex4f(0.0, 0.0, 0.0 , 1.0)
        glVertex4f(self.t[n].x, self.t[n].y, 0.0 , 1.0)
        glVertex4f(self.t[n].x, self.t[n].y, 0.0 , 1.0)
        glVertex4f(self.t[0].x, self.t[0].y, 0.0 , 1.0)
                
        glEnd()
        glPopMatrix()

    def colorear(self):
        self.rgb=[1,1,uniform(0,1)]

#####################################################################
def chocar(c1,c2):
    
    nt=normalizar(restar(c2.p,c1.p))

    if not (punto(c2.v,nt)>0 and punto(c1.v,nt)<0):
        tt=rotar(nt,pi/2)

        v1n=ponderar(punto(c1.v,nt),nt)
        v1t=ponderar(punto(c1.v,tt),tt)
        
        v2n=ponderar(punto(c2.v,nt),nt)
        v2t=ponderar(punto(c2.v,tt),tt)
        
        c1.v=sumar(v2n,v1t)
        c2.v=sumar(v1n,v2t)

        c1.colorear()
        c2.colorear()

def estanChocando(c1,c2):
    return distancia(c1.p,c2.p) - (c1.r + c2.r) < epsilon

def chocarBorde(c):
    if c.p.x+c.r>w:
        c.v.x=-abs(c.v.x)
        c.p.x=w-c.r
    if c.p.x<c.r:
        c.v.x=abs(c.v.x)
        c.p.x=c.r
    if c.p.y>h-c.r:
        c.v.y=-abs(c.v.y)
        c.p.y=h-c.r
    if c.p.y<c.r:
        c.v.y=abs(c.v.y)
        c.p.y=c.r

def accion(cs,dt):
    glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT)
    
    for i in range(len(cs)):
        cs[i].mover(dt/60.0)
        chocarBorde(cs[i])

        if showT:
            cs[i].dibujarT()
        else:
            cs[i].dibujar()

        for j in range(i+1,len(cs)):
            if estanChocando(cs[i],cs[j]):
                cs[i].elim = True
                cs[j].elim = True

    n=len(cs)
    aux = []
    for i in range(n):
        c = cs.pop()
        if not c.elim:
            aux.append(c)

    for a in aux:
        cs.append(a)

    glLoadIdentity()

#####################################################################
# Funciones de graficos
#####################################################################

def init():
    glShadeModel(GL_SMOOTH)
    glClearColor(0.0, 0.0, 0.0, 0.0)
    glClearDepth(1.0)
    glDisable(GL_DEPTH_TEST)
    glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST)

def reshape((width, height)):
    if height == 0:
        height = 1
    glViewport(0, 0, width, height)
    glMatrixMode(GL_PROJECTION)
    glLoadIdentity()
    gluOrtho2D(0.0, width, 0.0, height)
    glMatrixMode(GL_MODELVIEW)
    glLoadIdentity()

#####################################################################
# Programa principal
#####################################################################

def main(argv):

    global h,w,showT,g,rgb0

    showT=False
    rgb0=[1.0,1.0,1.0]

    nc=3
    rc=30
    w=800
    h=600

    if len(argv)==5:
        nc=int(argv[1])
        rc=float(argv[2])
        w=int(argv[3])
        h=int(argv[4])
    
    nt=int(1.3*rc)
    ag=pi/12

    pygame.init()
    pygame.display.set_mode((w,h), OPENGL|DOUBLEBUF)
    pygame.display.set_caption("colisiones")

    reshape((w,h))
    init()

    cs=[]
    
    g0=Vector(0.0,-4.0)
    g=g0
    
    for i in range(nc):
        p=Vector(uniform(rc,w-rc),uniform(rc,h-rc))
        v=Vector(uniform(-30,30),0.0)
        cs.append(Circulo(rc,p,v,rgb0,nt))

    t0=pygame.time.get_ticks()

    run=True

    while run:
        t1=pygame.time.get_ticks()
        
        for event in pygame.event.get():
            if event.type == QUIT:
                run=False
            if event.type == KEYDOWN:
                if event.key == K_t:
                    showT=not showT
                if event.key == K_q:
                    run=False
                if event.key == K_LEFT:
                    g=rotar(g,ag)
                if event.key == K_RIGHT:
                    g=rotar(g,-ag)
                if event.key == K_UP:
                    g=rotar(g,pi/2.0)
                if event.key == K_DOWN:
                    g=rotar(g,-pi/2.0)
                if event.key == K_n:
                    p=Vector(uniform(rc,w-rc),uniform(rc,h-rc))
                    v=Vector(uniform(-30,30),uniform(0,0))
                    cs.append(Circulo(rc,p,v,rgb0,nt))
                if event.key == K_m:
                    if len(cs)>0:
                        del cs[len(cs)-1]
                if event.key == K_c:
                    rgb0=[uniform(0,1),uniform(0,1),uniform(0,1)]
                    for c in cs:
                        c.rgb=rgb0
                if event.key == K_w:
                    glColor4f(1.0,1.0,1.0,0.0)
                if event.key == K_0:
                    if g.modulo()!=0:
                        g=Vector(0,0)
                    else:
                        g=g0
                    
        accion(cs,t1-t0)
        
        pygame.display.flip()
        pygame.time.wait(1000/30)

        t0=t1

    pygame.quit()

if __name__ == "__main__":
    import sys
    main(sys.argv)
    
#####################################################################
